; Keyboard controller program written in Z80 assembly
;
; This is a test...
;

_start
	; Enter here after reset
	ld sp,#2048		; Initialize stack pointer

	; Test the serial port
	; Send one character followed by a long pause
	ld a,#0x58
	call (sendchar)

	ld hl,#0
zzz
	dec hl
	ld a,h
	or l
	jr nz,zzz
	
	; Send a string
	ld hl,hello_msg
send_msg
	ld a,(hl)
	inc hl
	and a
	jr z,sm_done
	call (sendchar)
	jr send_msg
sm_done

	; Now, other stuff...
		
	xor a		; A <- 0
	ld b,a
	ld h,a
	ld l,a

scan
	out (#3),a
	push af
	ld a,b
	out (#2),a
delay
	push de
	pop de
	dec hl
	ld a,h
	or l
	jr nz,delay

	; Rotate A left inserting the inverse byte
	pop af
	cp #0x80	; Set C iff A < 0x7F
	rla

	jr nz,scan

	; Loop counter (increment when A <- 0)
	inc b

	; Output the loop counter on the serial port
	push af
	push hl
	push de
	ld de,hextbl
	ld h,#0
	ld l,b
	srl l
	srl l
	srl l
	srl l
	add hl,de
	ld a,(hl)
	call (sendchar)
	ld h,#0
	ld a,b
	and #0x0F
	ld l,a
	add hl,de
	ld a,(hl)
	call (sendchar)
	ld a,#32
	call (sendchar)
	pop de
	pop hl
	pop af
				
	jr scan

;
; Send a byte to the debug serial port
;
sendchar
	push af
sc_notready
	in a,(#1)
	cp #0x80		; Bit 7 = serial port ready
	jr c,sc_notready
	pop af
	out (#1),a
	ret
	
hello_msg
	byte "Hello, World!", 13, 10, 0

hextbl
	byte "0123456789ABCDEF"
